/*
 * name Blink.pde
 * date Tue Feb 05 16:48:00 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int  LED11 =  11;  // Arduino: Lilypad
int  LED12 =  12;  // Arduino: Pro Mini
int  LED13 =  13;  // Arduino: Diecimila

void setup() {
  initComponents();
  // Arduino の13pinに接続されているLEDを1秒間隔で点滅
  // initialize
  pinMode(LED11, OUTPUT);  // Arduino: Lilypad
  pinMode(LED12, OUTPUT);  // Arduino: Pro Mini
  pinMode(LED13, OUTPUT);  // Arduino: Diecimila
}

void loop() {
  digitalWrite(LED11, HIGH); // turn the LED on (HIGH is the voltage level)
  digitalWrite(LED12, LOW ); // turn the LED off by making the voltage LOW
  digitalWrite(LED13, LOW ); // turn the LED off by making the voltage LOW
  delay(1000);               // wait for a second
  digitalWrite(LED11, LOW ); // turn the LED off by making the voltage LOW
  digitalWrite(LED12, HIGH); // turn the LED on (HIGH is the voltage level)
  digitalWrite(LED13, LOW ); // turn the LED off by making the voltage LOW
  delay(1000);               // wait for a second
  digitalWrite(LED11, LOW ); // turn the LED off by making the voltage LOW
  digitalWrite(LED12, LOW ); // turn the LED off by making the voltage LOW
  digitalWrite(LED13, HIGH); // turn the LED on (HIGH is the voltage level)
  delay(1000);               // wait for a second
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のバルスメソッド
// 決して、使ってはならない。
void Balse() {
  System.exit(0);
}                                            

// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 11 : arduino11.setState(value); break;
        case 12 : arduino12.setState(value); break;
        case 13 : arduino13.setState(value); break;
    }
}

java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
  arduino11 = new Arduino(11 , "arduino lilypad 11",        0,   0, "controller_arduino_lilypad");      // 178, 229
  arduino12 = new Arduino(12 , "arduino pro mini red 12", 192,   0, "controller_arduino_pro_mini_red"); // 162, 349
  arduino13 = new Arduino(13 , "arduino diecimila 13",    360,   0, "controller_arduino_diecimila"   ); // 283, 254

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(0, 600);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Arduino arduino11;
private Arduino arduino12;
private Arduino arduino13;

// End of variables declaration//GEN-END:variables
