/*
 * name SliderXY.pde
 * date Sun Mar 24 08:42:46 JST 2013
 * 
 * Released under the 'Buy Me a Beer' license
 * (If we ever meet, you buy me a beer)
 */

import net.triring.emuduino.*;
import ddf.minim.AudioOutput;
// Pin割り当て
// constants won't change. They're used here to 
// set pin numbers:
int         D2 =   2;  // Led:Red
int         D3 =   3;  // Led:Orange
int         D4 =   4;  // Led:Yellow
int         D5 =   5;  // Led:Green
int         D6 =   6;  // Led:Cyan
int         D7 =   7;  // Led:Blue
int         D8 =   8;  // Led:Magenta
int         D9 =   9;  // Led:Pink
int        D11 =  11;  // Led:White
int        D12 =  12;  // Switch:Push
int         A0 =   0;  // Slider:INPUT:HORIZONTAL
int         A1 =   1;  // Slider:INPUT:VERTICAL

int Leds[] = { 2, 3, 4, 5, 6, 7, 8, 9, 11 };
//int State[9];

void setup() {
  // 水平，垂直のSliderのテストプログラムです。
  // トグルスイッチOff:水平Slider
  // トグルスイッチOn :垂直Slider

  initComponents();
  // initialize
     pinMode(D2,  OUTPUT);  // Led:Red
     pinMode(D3,  OUTPUT);  // Led:Orange
     pinMode(D4,  OUTPUT);  // Led:Yellow
     pinMode(D5,  OUTPUT);  // Led:Green
     pinMode(D6,  OUTPUT);  // Led:Cyan
     pinMode(D7,  OUTPUT);  // Led:Blue
     pinMode(D8,  OUTPUT);  // Led:Magenta
     pinMode(D9,  OUTPUT);  // Led:Pink
     pinMode(D11, OUTPUT);  // Led:White
     pinMode(D12,  INPUT);  // Switch:Push
}

void loop() {
  int i;
  int mode = digitalRead(D12);
  int value;
  if (LOW  == mode) value = (int)(analogRead(A0)/103);
  else              value = (int)(analogRead(A1)/103); 

  for (i = 0; i < 9; i++) {
    if (value > i) {
    digitalWrite(Leds[i], HIGH);
    } else {
    digitalWrite(Leds[i], LOW );
    }
  }
  delay(500);
}

void draw() {
  loop();
}

// システムの機能を完全に停止させる禁断のメソッド
// 決して、使ってはならない。
void balse() {
  System.exit(0);
}                                            

// digital INPUT
int digitalRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case 12 : value = switch12.isState(); break;
    }
    return value;
}
// digital OUTPUT
void digitalWrite(int outPin, int value) {
    switch (outPin) {
        case 2 : led2.setState(value); break;
        case 3 : led3.setState(value); break;
        case 4 : led4.setState(value); break;
        case 5 : led5.setState(value); break;
        case 6 : led6.setState(value); break;
        case 7 : led7.setState(value); break;
        case 8 : led8.setState(value); break;
        case 9 : led9.setState(value); break;
        case 11 : led11.setState(value); break;
    }
}
// analog INPUT
int analogRead(int inPin) {
    int value = 0;
    switch (inPin) {
        case   0 : value = slider0.getValue(); break;
        case   1 : value = slider1.getValue(); break;
    }
    return value;
}
java.awt.Image readImage(String imgfile) {
  PImage pImage = loadImage(imgfile);
  return pImage.getImage();
}

//TimerTask内部クラス
class TimerTaskAudioStop extends java.util.TimerTask {
  public void run() {
    ToneFlag = 0;
    auOut.noSound();
    auOut.mute();
  }
}

// 指定された時間だけ停止する。単位はus
void delayMicroseconds(int t_us) {
  try {
    Thread.sleep(0, t_us * 1000);  // マイクロ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// 指定された時間だけ停止する。単位はms
void delay(long t_ms) {
  try {
    Thread.sleep(t_ms);  // ミリ秒単位の停止
  } 
  catch (InterruptedException e) {
  }
}

// arduino起動後の時間をus単位で返す。
long micros() {
  return (SystemStartTimeNS - System.nanoTime()) * 1000;
}

// 以下は、互換性のためだけに用意したダミー関数である。
void pinMode(int pin, int mode) {
   print("pin = " + pin + ", mode = " + mode);
}

/**
 * This method is called from within the constructor to initialize the form.
 * WARNING: Do NOT modify this code. The content of this method is always
 * regenerated by the Form Editor.
 */
// @SuppressWarnings("unchecked")
// <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
private void initComponents() {
  ToneFlag = 0;

  // digital
       led2 = new Led(2 ,     "red",        0,  480);
       led3 = new Led(3 ,     "orange",   120,  420);
       led4 = new Led(4 ,     "yellow",   240,  360);
       led5 = new Led(5 ,     "green",    360,  300);
       led6 = new Led(6 ,     "cyan",     480,  240);
       led7 = new Led(7 ,     "blue",     600,  180);
       led8 = new Led(8 ,     "magenta",  720,  120);
       led9 = new Led(9 ,     "pink",     840,   60);
      led11 = new Led(11 ,    "white",    960,    0);
   switch12 = new Switch(12 , "Push12",   480,    0);
    slider0 = new Slider(0 ,  "INPUT0",   480,  480, javax.swing.JSlider.HORIZONTAL);
    slider0.setSize(384, 120);
    slider1 = new Slider(1 , "INPUT1",      0,  120, javax.swing.JSlider.VERTICAL);
    slider1.setSize(120, 280);

  minim = new ddf.minim.Minim(this);
  // get a line out from Minim, default bufferSize is 1024, default sample rate is 44100, bit depth is 16
  auOut = minim.getLineOut(ddf.minim.Minim.STEREO);
  // create a sine wave Oscillator, set to 440 Hz, at 0.5 amplitude, sample rate from line out
  sine = new ddf.minim.signals.SineWave(440, 0.5, auOut.sampleRate());
  // set the portamento speed on the oscillator to 200 milliseconds
  sine.portamento(200);

  DelayTimer = new java.util.Timer(); //タイマーインスタンス作成

  // add the oscillator to the line out
  auOut.addSignal(sine);
  auOut.noSound();  // Disables all signals currently attached to this.
  auOut.mute();
  ToneFlag = 0;

  SystemStartTimeMS = System.currentTimeMillis();  //ミリ秒で表される現在の時間を返します。
  SystemStartTimeNS = System.nanoTime(); // 利用可能でもっとも正確なシステムタイマーの現在の値をナノ秒単位で返します。
  size(320, 128);
  setLocation(0, 600);
  background(15, 115, 145);
  fill( 15, 115, 145);  rect(0, 0, 320, 128);
  fill( 30, 160, 145);  textSize(60); text(TITLE , 24, 68);
  fill( 45, 192, 145);  textSize(60); text(TITLE , 22, 66);
  fill(255, 255, 255);  textSize(60); text(TITLE , 20, 64);
  fill(255, 255, 255);  textSize(18); text("Ver. " + Arduino.getVersion(), 120, 108);
  setLocation(120,   0);
}// </editor-fold>//GEN-END:initComponents

// 変数の宣言部
// Variables declaration - do not modify//GEN-BEGIN:variables

private String TITLE   = "Emuduino";
private String VERSION = "0.49"; // Arduino.javaで使用するプロパティファイル中のバージョンを参照する。

private long SystemStartTimeMS;
private long SystemStartTimeNS;

private static final int HIGH   = 0x1;
private static final int LOW    = 0x0;
private static final int INPUT  = 0x0;
private static final int OUTPUT = 0x1;

private int ToneFlag = 0;  // 0の場合は停止状態。再生中は，その周波数を保持

private java.util.Timer            DelayTimer;
private java.util.TimerTask        TimerTaskAudioStop;
private ddf.minim.Minim            minim; // http://code.compartmental.net/minim/javadoc/
private ddf.minim.AudioOutput      auOut;
private ddf.minim.signals.SineWave sine;

private Led led2;
private Led led3;
private Led led4;
private Led led5;
private Led led6;
private Led led7;
private Led led8;
private Led led9;
private Led led11;
private Switch switch12;
private Slider slider0;
private Slider slider1;

// End of variables declaration//GEN-END:variables
